Bug 208470 - ich7r sata controller not working correctly
ich7r sata controller not working correctly
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Don Howard
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2006-09-28 15:30 EDT by Aleksandar Milivojevic
Modified: 2007-11-30 17:06 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-10-03 16:48:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Aleksandar Milivojevic 2006-09-28 15:30:49 EDT
Description of problem:
I've attempted to test if kernel from EL 2.1 would work on SuperMicro PDSMi
motherboard (Intel E7230 chipset, ICH7R + PXH-V + Intel 82573V) -- to freshen
some old failing hardware without reinstalling the OS.  I've configured SATA to
work in PATA compatibility mode in BIOS.  The two PATA ports are on ide0, and 4
SATA ports are on ide2 and ide3 (there doesn't seem to be ide1).

The kernel on EL 2.1 installation CD would simply hang when detecting IDE
busses.  I've installed the EL 2.1 on another SATA based system, upgraded kernel
to 2.4.9-e.70 and than moved the drives back.  After fixing initrd and grub.conf
(hda changed to hde), the system starts booting, kernel sees the drives (doesn't
hang anymore), root file system is mounted.  However, now system hangs at random
places when execturing scripts in /etc/rc3.d.  Sometimes it hangs when mounting
file systems, sometimes it goes as far as running kudzu.  But eventually it
hangs at some random point.

When it hangs, there are no error messages on the screen.  It just halts.

I guess that system should run stable if I have it configured in BIOS in PATA
compatibility mode.  The worst case it would use PIO if kernel doesn't have UDMA
drivers for that version of IDE controller.  Unless Intel or SuperMicro screwed
up something in chipset and/or BIOS, this is probably bug in the kernel.

BTW, same system works just fine with EL3 and EL4 kernel using SATA drivers. 
However if I force PATA compatibility mode in BIOS (and pass couple of kernel
options to prevent it from ignoring BIOS settings and using ata_piix SATA
drivers), I get similar problems with those kernels too.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
Actual results:

Expected results:

Additional info:
Comment 1 Don Howard 2006-10-03 16:48:45 EDT
2.1 predates this hardware and the kernel is only being updated for security
issues at this point (no further updates for new hardware), so I doubt that we
can offer you much help.  =(  FWIW, I was able to get RHEL21u6 install disks to
recognize sata drives attached to a ich5.

There is some ongoing work to support pata in libata, but it doesn't appear to
be included upstream yet, and won't be packported to 2.1.

It looks like supermicro offers a binary driver for the ich7r, but only on rhel3
and later.

Comment 2 Aleksandar Milivojevic 2006-10-03 17:04:01 EDT
Thanks for looking into this.

Just a bit more info, also covering RHEL 3.8 and 4.4.

I was also successfull in getting 2.1 to work on ICH5R based system, with drives
in either native or PATA emulation mode.

RHEL 3.8 installs fine on ICH7R.  However, it worked only with SATA drives in
native mode and AHCI turned off (there's no ahci driver in RHEL3's kernel).  If
drives were in PATA emulation mode, it simply wouldn't work.

RHEL 4.4 works on ICH7R in native SATA mode with AHCI on (using ahci driver) and
with AHCI off (uses ata_piix driver).  It doesn't work with drives in PATA
emulation mode.

I guess there's something strange in ICH7R's PATA emulation mode that Linux
kernels (even the 2.6 kernels) don't like.  Linux kernels (2.4 and 2.6) seem to
be happy with ICH5 PATA emulation though...
Comment 3 Don Howard 2006-10-09 16:22:27 EDT
Hi Aleksandar -

Please open a RHEL4 bug to persue this for 2.6 kernel.  Do you know if this
issue is present with fedora kernels?
Comment 4 Aleksandar Milivojevic 2006-10-09 23:17:46 EDT
I don't any ICH7R hardware left for testing (all went to production).  If I get
any additional hw to play with, I'll try it out and open the bug under RHEL4.

Note You need to log in before you can comment on or make changes to this bug.